searchData={"items":[{"type":"module","title":"AshCubDB","doc":"`AshCubDB` is an [Ash DataLayer](https://ash-hq.org/docs/module/ash/latest/ash-datalayer)\nwhich adds support for persisting Ash resources with [CubDB](https://hex.pm/packages/cubdb).\n\nCubDB is an Elixir-based key value store which supports all Erlang-native\nterms.  More information can be found in \n[the CubDB readme](https://hexdocs.pm/cubdb/readme.html).","ref":"AshCubDB.html"},{"type":"function","title":"AshCubDB.back_up/2","doc":"Creates a backup of the database into the target directory path.\n\nWrapper around `CubDB.back_up/2`","ref":"AshCubDB.html#back_up/2"},{"type":"function","title":"AshCubDB.clear/1","doc":"Deletes all entries, resulting in an empty database.\n\nWrapper around `CubDB.clear/1`","ref":"AshCubDB.html#clear/1"},{"type":"function","title":"AshCubDB.compact/1","doc":"Runs a database compaction.\n\nWrapper around `CubDB.compact/1`","ref":"AshCubDB.html#compact/1"},{"type":"function","title":"AshCubDB.compacting?/1","doc":"Returns true if a compaction operation is currently running, false otherwise.\n\nWrapper around `CubDB.compacting?/1`","ref":"AshCubDB.html#compacting?/1"},{"type":"function","title":"AshCubDB.current_db_file/1","doc":"Returns the path of the current database file.\n\nWrapper around `CubDB.current_db_file/1`","ref":"AshCubDB.html#current_db_file/1"},{"type":"function","title":"AshCubDB.data_dir/1","doc":"Returns the path of the data directory, as given when the `CubDB` process was started. \n\nWrapper around `CubDB.data_dir/1`","ref":"AshCubDB.html#data_dir/1"},{"type":"function","title":"AshCubDB.dirt_factor/1","doc":"Returns the dirt factor.\n\nWrapper around `CubDB.dirt_factor/1`","ref":"AshCubDB.html#dirt_factor/1"},{"type":"function","title":"AshCubDB.file_sync/1","doc":"Performs an `fsync`, forcing to flush all data that might be buffered by the OS to disk.\n\nWrapper around `CubDB.file_sync/1`","ref":"AshCubDB.html#file_sync/1"},{"type":"function","title":"AshCubDB.halt_compaction/1","doc":"Stops a running compaction.\n\nWrapper around `CubDB.halt_compaction/1`","ref":"AshCubDB.html#halt_compaction/1"},{"type":"function","title":"AshCubDB.start/1","doc":"Ensure that the CubDB process is running for the specified resource.","ref":"AshCubDB.html#start/1"},{"type":"function","title":"AshCubDB.stop/1","doc":"Stop the CubDB process running for a specific resource.","ref":"AshCubDB.html#stop/1"},{"type":"module","title":"AshCubDB.DataLayer","doc":"A CubDB data layer for Ash.","ref":"AshCubDB.DataLayer.html"},{"type":"module","title":"DSL Documentation - AshCubDB.DataLayer","doc":"#","ref":"AshCubDB.DataLayer.html#module-dsl-documentation"},{"type":"module","title":"Index - AshCubDB.DataLayer","doc":"* cubdb\n\n#","ref":"AshCubDB.DataLayer.html#module-index"},{"type":"module","title":"Docs - AshCubDB.DataLayer","doc":"","ref":"AshCubDB.DataLayer.html#module-docs"},{"type":"module","title":"cubdb - AshCubDB.DataLayer","doc":"CubDB data layer configuration.\n\n\n\n\nExamples:\n```\ncubdb do\n  directory \"/opt/storage/my_awesome_resource\"\n  auto_compact? true\n  auto_file_sync? true\n  name :my_awesome_resource\nend\n\n```\n\n\n\n\n---\n\n* `:directory` - The directory within which to store the CubDB data.  \n  If none is supplied, then one will be automatically generated in the\n  `priv` directory of the parent OTP application.\n\n* `:otp_app` (`t:atom/0`) - The OTP application in whose `priv` directory data should be stored.  \n  Only used if `directory` is not supplied.  When not provided\n  `Application.get_application/1` will be called for the resource.\n\n* `:auto_compact?` (`t:boolean/0`) - Whether or not to automatically compact the CubDB database.  \n  See [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-is-compaction) for more information. The default value is `true`.\n\n* `:auto_file_sync?` (`t:boolean/0`) - Whether or not to automatically flush the buffer to disk on write.  \n  See [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-does-file-sync-mean) The default value is `true`.\n\n* `:name` (`t:atom/0`) - The name of the CubDB database.  \n  By default this is the name of the resource module, however in some\n  (rare) circumstances you may wish to specifically name the database.","ref":"AshCubDB.DataLayer.html#module-cubdb"},{"type":"module","title":"AshCubDB.Dir","doc":"Utilities for working with the underlying data directory.","ref":"AshCubDB.Dir.html"},{"type":"function","title":"AshCubDB.Dir.readable?/1","doc":"Is the directory able to be read from by the current user?","ref":"AshCubDB.Dir.html#readable?/1"},{"type":"function","title":"AshCubDB.Dir.writable?/1","doc":"Is the directory able to be written to by the current user?","ref":"AshCubDB.Dir.html#writable?/1"},{"type":"module","title":"AshCubDB.Info","doc":"Auto-generated introspection for the AshCubDB DSL.","ref":"AshCubDB.Info.html"},{"type":"function","title":"AshCubDB.Info.cubdb_auto_compact?/1","doc":"Whether or not to automatically compact the CubDB database.\n\nSee [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-is-compaction) for more information.","ref":"AshCubDB.Info.html#cubdb_auto_compact?/1"},{"type":"function","title":"AshCubDB.Info.cubdb_auto_file_sync?/1","doc":"Whether or not to automatically flush the buffer to disk on write.\n\nSee [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-does-file-sync-mean)","ref":"AshCubDB.Info.html#cubdb_auto_file_sync?/1"},{"type":"function","title":"AshCubDB.Info.cubdb_directory/1","doc":"The directory within which to store the CubDB data.\n\nIf none is supplied, then one will be automatically generated in the\n`priv` directory of the parent OTP application.","ref":"AshCubDB.Info.html#cubdb_directory/1"},{"type":"function","title":"AshCubDB.Info.cubdb_directory!/1","doc":"The directory within which to store the CubDB data.\n\nIf none is supplied, then one will be automatically generated in the\n`priv` directory of the parent OTP application.","ref":"AshCubDB.Info.html#cubdb_directory!/1"},{"type":"function","title":"AshCubDB.Info.cubdb_name/1","doc":"The name of the CubDB database.\n\nBy default this is the name of the resource module, however in some\n(rare) circumstances you may wish to specifically name the database.","ref":"AshCubDB.Info.html#cubdb_name/1"},{"type":"function","title":"AshCubDB.Info.cubdb_name!/1","doc":"The name of the CubDB database.\n\nBy default this is the name of the resource module, however in some\n(rare) circumstances you may wish to specifically name the database.","ref":"AshCubDB.Info.html#cubdb_name!/1"},{"type":"function","title":"AshCubDB.Info.cubdb_options/1","doc":"cubdb DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshCubDB.Info.html#cubdb_options/1"},{"type":"function","title":"AshCubDB.Info.cubdb_otp_app/1","doc":"The OTP application in whose `priv` directory data should be stored.\n\nOnly used if `directory` is not supplied.  When not provided\n`Application.get_application/1` will be called for the resource.","ref":"AshCubDB.Info.html#cubdb_otp_app/1"},{"type":"function","title":"AshCubDB.Info.cubdb_otp_app!/1","doc":"The OTP application in whose `priv` directory data should be stored.\n\nOnly used if `directory` is not supplied.  When not provided\n`Application.get_application/1` will be called for the resource.","ref":"AshCubDB.Info.html#cubdb_otp_app!/1"},{"type":"function","title":"AshCubDB.Info.field_layout/1","doc":"Retrieve the cached field layout for the resource.","ref":"AshCubDB.Info.html#field_layout/1"},{"type":"module","title":"AshCubDB.Migration","doc":"We store and check metadata when opening a database to ensure that the\nresource and attributes match, and possibly perform migrations.","ref":"AshCubDB.Migration.html"},{"type":"function","title":"AshCubDB.Migration.check/2","doc":"Check that a newly opened database doesn't need to be migrated.","ref":"AshCubDB.Migration.html#check/2"},{"type":"module","title":"AshCubDB.Query","doc":"A struct which holds information about a resource query as it is being built.","ref":"AshCubDB.Query.html"},{"type":"type","title":"AshCubDB.Query.t/0","doc":"","ref":"AshCubDB.Query.html#t:t/0"},{"type":"module","title":"AshCubDB.Serde","doc":"Handle serialising and deserialising of records into CubDB.","ref":"AshCubDB.Serde.html"},{"type":"function","title":"AshCubDB.Serde.deserialise/3","doc":"Convert the key and data back into a record..","ref":"AshCubDB.Serde.html#deserialise/3"},{"type":"function","title":"AshCubDB.Serde.serialise/1","doc":"Serialise the record into key and value tuples for storage in CubDB.","ref":"AshCubDB.Serde.html#serialise/1"},{"type":"extras","title":"Read Me","doc":"# AshCubDB\n\n[![Build Status](https://drone.harton.nz/api/badges/james/ash_cubdb/status.svg?ref=refs/heads/main)](https://drone.harton.nz/cinder/cinder)\n[![Hippocratic License HL3-FULL](https://img.shields.io/static/v1?label=Hippocratic%20License&message=HL3-FULL&labelColor=5e2751&color=bc8c3d)](https://firstdonoharm.dev/version/3/0/full.html)\n\nAn [Ash DataLayer](https://ash-hq.org/docs/module/ash/latest/ash-datalayer)\nwhich adds support for [CubDB](https://hex.pm/packages/cubdb).","ref":"readme.html"},{"type":"extras","title":"Status - Read Me","doc":"AshCubDb is still a work in progress.  Feel free to give it a go.\n\n| Feature                 | Status |\n|-------------------------|--------|\n| Create                  | ✅     |\n| Upsert (by primary key) | ✅     |\n| Upsert (by identity)    | ❌     |\n| Read (all)              | ✅     |\n| Read (by primary key)   | ✅     |\n| Read (filters)          | ✅     |\n| Read (sort)             | ✅     |\n| Read (calculations)     | ❌     |\n| Read (aggregates)       | ❌     |\n| Update                  | ✅     |\n| Destroy                 | ✅     |","ref":"readme.html#status"},{"type":"extras","title":"Github Mirror - Read Me","doc":"This repository is mirrored [on Github](https://github.com/jimsynz/smokestack)\nfrom it's primary location [on my Forejo instance](https://code.harton.nz/james/ash_cubdb).\nFeel free to raise issues and open PRs on Github.","ref":"readme.html#github-mirror"},{"type":"extras","title":"Installation - Read Me","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `ash_cubdb` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_cubdb, \"~> 0.4.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"License - Read Me","doc":"This software is licensed under the terms of the\n[HL3-FULL](https://firstdonoharm.dev), see the `LICENSE.md` file included with\nthis package for the terms.\n\nThis license actively proscribes this software being used by and for some\nindustries, countries and activities. If your usage of this software doesn't\ncomply with the terms of this license, then [contact me](mailto:james@harton.nz)\nwith the details of your use-case to organise the purchase of a license - the\ncost of which may include a donation to a suitable charity or NGO.","ref":"readme.html#license"},{"type":"extras","title":"DSL: AshCubDB.DataLayer","doc":"# DSL: AshCubDB.DataLayer\n\nA CubDB data layer for Ash.","ref":"dsl-ashcubdb-datalayer.html"},{"type":"extras","title":"DSL Documentation - DSL: AshCubDB.DataLayer","doc":"#","ref":"dsl-ashcubdb-datalayer.html#dsl-documentation"},{"type":"extras","title":"Index - DSL: AshCubDB.DataLayer","doc":"* cubdb\n\n#","ref":"dsl-ashcubdb-datalayer.html#index"},{"type":"extras","title":"Docs - DSL: AshCubDB.DataLayer","doc":"","ref":"dsl-ashcubdb-datalayer.html#docs"},{"type":"extras","title":"cubdb - DSL: AshCubDB.DataLayer","doc":"CubDB data layer configuration.\n\n\n\n\nExamples:\n```\ncubdb do\n  directory \"/opt/storage/my_awesome_resource\"\n  auto_compact? true\n  auto_file_sync? true\n  name :my_awesome_resource\nend\n\n```\n\n\n\n\n---\n\n* `:directory` - The directory within which to store the CubDB data.  \n  If none is supplied, then one will be automatically generated in the\n  `priv` directory of the parent OTP application.\n\n* `:otp_app` (`t:atom/0`) - The OTP application in whose `priv` directory data should be stored.  \n  Only used if `directory` is not supplied.  When not provided\n  `Application.get_application/1` will be called for the resource.\n\n* `:auto_compact?` (`t:boolean/0`) - Whether or not to automatically compact the CubDB database.  \n  See [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-is-compaction) for more information. The default value is `true`.\n\n* `:auto_file_sync?` (`t:boolean/0`) - Whether or not to automatically flush the buffer to disk on write.  \n  See [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-does-file-sync-mean) The default value is `true`.\n\n* `:name` (`t:atom/0`) - The name of the CubDB database.  \n  By default this is the name of the resource module, however in some\n  (rare) circumstances you may wish to specifically name the database.","ref":"dsl-ashcubdb-datalayer.html#cubdb"},{"type":"extras","title":"cubdb - DSL: AshCubDB.DataLayer","doc":"CubDB data layer configuration.\n\n\n\n\n#","ref":"dsl-ashcubdb-datalayer.html#cubdb"},{"type":"extras","title":"Examples - DSL: AshCubDB.DataLayer","doc":"```\ncubdb do\n  directory \"/opt/storage/my_awesome_resource\"\n  auto_compact? true\n  auto_file_sync? true\n  name :my_awesome_resource\nend\n\n```\n\n\n\n\n#","ref":"dsl-ashcubdb-datalayer.html#examples"},{"type":"extras","title":"Options - DSL: AshCubDB.DataLayer","doc":"Name \n       Type \n       Default \n       Docs \n     \n   \n   \n     \n   \n     \n       \n        directory\n       \n     \n      \n   \n   \n     nil | String.t \n   \n   \n    \n   \n   \n    The directory within which to store the CubDB data.\n\nIf none is supplied, then one will be automatically generated in the\n`priv` directory of the parent OTP application.\n\n   \n \n\n \n   \n     \n       \n        otp_app\n       \n     \n      \n   \n   \n     atom \n   \n   \n    \n   \n   \n    The OTP application in whose `priv` directory data should be stored.\n\nOnly used if `directory` is not supplied.  When not provided\n`Application.get_application/1` will be called for the resource.\n\n   \n \n\n \n   \n     \n       \n        auto_compact?\n       \n     \n      \n   \n   \n     boolean \n   \n   \n     true \n   \n   \n    Whether or not to automatically compact the CubDB database.\n\nSee [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-is-compaction) for more information.\n\n   \n \n\n \n   \n     \n       \n        auto_file_sync?\n       \n     \n      \n   \n   \n     boolean \n   \n   \n     true \n   \n   \n    Whether or not to automatically flush the buffer to disk on write.\n\nSee [the CubDB documentation](https://hexdocs.pm/cubdb/faq.html#what-does-file-sync-mean)\n\n   \n \n\n \n   \n     \n       \n        name\n       \n     \n      \n   \n   \n     atom \n   \n   \n    \n   \n   \n    The name of the CubDB database.\n\nBy default this is the name of the resource module, however in some\n(rare) circumstances you may wish to specifically name the database.","ref":"dsl-ashcubdb-datalayer.html#options"}],"content_type":"text/markdown"}